# vim: set ts=2 sw=2 et si sm:

WSGIDaemonProcess snapshot.debian.org user=nobody group=nogroup home=/ processes=6 threads=9 listen-backlog=150 queue-timeout=5 maximum-requests=5000 inactivity-timeout=1800 umask=0077 display-name=wsgi-snapshot.debian.org

<VirtualHost *:80>
  ServerName snapshot-dev.debian.org
  ServerAdmin team@snapshot.debian.org

  ErrorLog  /var/log/apache2/snapshot-dev.debian.org-error.log
  CustomLog /var/log/apache2/snapshot-dev.debian.org-access.log combined

  Alias /static      /srv/snapshot.debian.org/code/web/app/snapshot/static
  Alias /robots.txt  /srv/snapshot.debian.org/code/web/app/public/robots.txt

  RewriteEngine on

  # forbid POST requests
  RewriteCond %{REQUEST_METHOD} POST
  RewriteRule .* - [F,L]

  RewriteRule "^/file/([0-9a-f]{40})$" "http://snapshot.debian.org/file/$1"

  <Directory /srv/snapshot.debian.org/code/web/app/public>
    Require all granted
  </Directory>
  <Directory /srv/snapshot.debian.org/code/web/app/snapshot/static>
    Require all granted
  </Directory>
  <Directory /srv/snapshot.debian.org/bin>
    <Files snapshot.wsgi>
      Require all granted
    </Files>
  </Directory>

  WSGIScriptAlias / /srv/snapshot.debian.org/bin/snapshot.wsgi
  WSGIProcessGroup snapshot.debian.org
  WSGIApplicationGroup %{GLOBAL}

  <IfModule mod_qos.c>
    QS_LocRequestLimitDefault  30
  </IfModule>
</VirtualHost>

<VirtualHost *:80>
  ServerName snapshot.debian.org
  ServerAlias snapshot-master.debian.org snapshot-*.debian.org
  ServerAdmin team@snapshot.debian.org

  ErrorLog  /var/log/apache2/snapshot.debian.org-error.log
  CustomLog /var/log/apache2/snapshot.debian.org-access.log combined
  CustomLog /var/log/apache2/snapshot.debian.org-access-latency.log ncsa-with-latency

  Alias /static      /srv/snapshot.debian.org/code/web/app/snapshot/static
  Alias /robots.txt  /srv/snapshot.debian.org/code/web/app/public/robots.txt

  SetEnv GIT_PROJECT_ROOT /srv/snapshot.debian.org/all-git
  AliasMatch ^/gits/(.*)$ /srv/snapshot.debian.org/all-git/$1

  RewriteEngine on

  # forbid POST requests
  RewriteCond %{REQUEST_METHOD} POST
  RewriteRule .* - [F,L]

  RewriteRule ^/archive/backports.org/(.*) /archive/debian-backports/$1 [L,R]
  RewriteRule ^/git/(.*) /gits/snapshot.git/$1 [PT]

  <Location /gits/>
    Require all granted
  </Location>
  <Directory /srv/snapshot.debian.org/code/web/app/public>
    Require all granted
  </Directory>
  <Directory /srv/snapshot.debian.org/code/web/app/snapshot/static>
    Require all granted
  </Directory>
  <Directory /srv/snapshot.debian.org/bin>
    <Files snapshot.wsgi>
      Require all granted
    </Files>
  </Directory>

  AliasMatch "^/file/([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{36})/?([^/]+)?$" "/srv/snapshot.debian.org/farm/$1/$2/$1$2$3"
  <% if ['snapshot-mlm-01', 'sallinen'].include?(@trusted['hostname']) -%>
    # we temporarily and manually enabled mod proxy in apache
    SSLProxyEngine on
    RewriteCond %{REQUEST_URI} "^/file/[0-9a-f]{40}"
    RewriteCond "/srv/snapshot.debian.org/farm/$1/$2/$1$2$3" !-f
    #RewriteRule "^/file/([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{36})$" - [G]
    RewriteRule "^/file/([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{36})$" https://snapshot-lw07.debian.org/file/$1$2$3 [P]
  <% end -%>

  <Directory /srv/snapshot.debian.org/farm>
    Require all granted
    SetEnvIf Request_URI "^/file/[0-9a-f]{2}[0-9a-f]{2}[0-9a-f]{36}/([^/]+)$" FILENAME=$1
    #ExpiresActive on
    #ExpiresDefault "access plus 1 year"
    Header set Cache-Control "max-age=31536000, public"
    Header set Content-Disposition "attachment; filename=%{FILENAME}e" env=FILENAME
  </Directory>

  WSGIScriptAlias / /srv/snapshot.debian.org/bin/snapshot.wsgi
  WSGIProcessGroup snapshot.debian.org
  WSGIApplicationGroup %{GLOBAL}

  <IfModule mod_qos.c>
    QS_LocRequestLimitDefault  30
  </IfModule>
</VirtualHost>

<VirtualHost *:80>
  ServerName snapshot.debian.net
  ServerAdmin team@snapshot.debian.org

  ErrorLog  /var/log/apache2/snapshot.debian.net-error.log
  CustomLog /var/log/apache2/snapshot.debian.net-access.log combined

  RewriteRule ^/(.*)$ http://snapshot.debian.org/ [R]
</VirtualHost>

<VirtualHost *:80>
  ServerName snapshots.debian.org
  RedirectPermanent / http://snapshot.debian.org/
</VirtualHost>
